DEFAULT_ALL_OPPORTUNITIES_QUERY = """
SELECT
    Id,
    Account_Billing_Country__c,
    Account_Owner__c,
    AccountId,
    Amount,
    Amount_EUR__c,
    CampaignId,
    Close_Month_Formula__c,
    CloseDate,
    ContactId,
    CurrencyIsoCode,
    EndDate__c,
    ExpectedRevenue,
    Fiscal,
    FiscalQuarter,
    FiscalYear,
    FRM_JiraDefaultName__c,
    GACLIENTID__c,
    GATRACKID__c,
    GAUSERID__c,
    Global__c,
    HasOpportunityLineItem,
    HasOverdueTask,
    HasProposal__c,
    IsClosed,
    IsWon,
    Jira_component_required__c,
    Jira_Estimated_Work_Load__c,
    Jira_Number__c,
    Jira_Work_Load__c,
    JiraComponentURL__c,
    LeadId__c,
    LeadSource,
    LKP_GoogleFundingOpportunity__c,
    Loss_Reason__c,
    Market_Scope__c,
    MS_Account_Company_Invoicing__c,
    MS_Account_Invoice_Country_Code__c,
    MS_Company_Origin__c,
    Name,
    Opportunity_Name_Short__c,
    Opportunity_requestor__c,
    OwnerId,
    Probability,
    RecordTypeId,
    ROI_Analysis_Completed__c,
    Servicios_Asociados__c,
    StageName,
    Start_Date__c,
    Tier_Short__c,
    TotalOpportunityQuantity,
    Year_Created__c,
    LKP_Project__c,
    (
        SELECT
            Id,
            Product2.Id,
            Product2.LKP_ProfitCenter__r.Name,
            toLabel(Product2.LKP_ProfitCenter__r.PCK_Country__c),
            FRM_ProductName__c,
            Quantity,
            UnitPrice
        FROM
            OpportunityLineItems
    )
FROM
    Opportunity

"""
# WHERE
#     Id='0063X000013A8JPQA0'

DEFAULT_ALL_OPPORTUNITIES_CREATE_TABLE_QUERY = """
CREATE TABLE all_opportunity (
    opportunity_id VARCHAR(255) PRIMARY KEY,
    account_billing_country VARCHAR(255) DEFAULT NULL,
    account_owner VARCHAR(255) DEFAULT NULL,
    account_id VARCHAR(255) DEFAULT NULL,
    amount VARCHAR(255) DEFAULT NULL,
    amount_eur VARCHAR(255) DEFAULT NULL,
    campaign_id VARCHAR(255) DEFAULT NULL,
    close_month_formula VARCHAR(255) DEFAULT NULL,
    close_date VARCHAR(255) DEFAULT NULL,
    contact_id VARCHAR(255) DEFAULT NULL,
    curreny_iso_code VARCHAR(255) DEFAULT NULL,
    end_date VARCHAR(255) DEFAULT NULL,
    expected_revenue VARCHAR(255) DEFAULT NULL,
    fiscal VARCHAR(255) DEFAULT NULL,
    fiscal_quarter VARCHAR(255) DEFAULT NULL,
    fiscal_year VARCHAR(255) DEFAULT NULL,
    jira_default_name VARCHAR(255) DEFAULT NULL,
    ga_client_id VARCHAR(255) DEFAULT NULL,
    ga_track_id VARCHAR(255) DEFAULT NULL,
    ga_user_id VARCHAR(255) DEFAULT NULL,
    is_global VARCHAR(255) DEFAULT NULL,
    has_proposal BOOLEAN,
    has_opportunity_lineitem BOOLEAN,
    has_overdue_task BOOLEAN,
    hasproposal BOOLEAN,
    is_closed BOOLEAN,
    is_won BOOLEAN,
    jira_component_required BOOLEAN,
    jira_estimated_work_load VARCHAR(255) DEFAULT NULL,
    jira_number VARCHAR(255) DEFAULT NULL,
    jira_work_load VARCHAR(255) DEFAULT NULL,
    jira_component_url VARCHAR(255) DEFAULT NULL,
    lead_id VARCHAR(255) DEFAULT NULL,
    lead_source VARCHAR(255) DEFAULT NULL,
    google_funding_opportunity VARCHAR(255) DEFAULT NULL,
    loss_reason VARCHAR(255) DEFAULT NULL,
    market_scope VARCHAR(255) DEFAULT NULL,
    ms_account_company_invoicing VARCHAR(255) DEFAULT NULL,
    ms_account_invoice_country_code VARCHAR(255) DEFAULT NULL,
    ms_company_origin VARCHAR(255) DEFAULT NULL,
    opportunity_name VARCHAR(255) DEFAULT NULL,
    opportunity_name_short VARCHAR(255) DEFAULT NULL,
    opportunity_requestor VARCHAR(255) DEFAULT NULL,
    owner_id VARCHAR(255) DEFAULT NULL,
    probability FLOAT DEFAULT NULL,
    record_type_id VARCHAR(255) DEFAULT NULL,
    roi_analysis_completed VARCHAR(255) DEFAULT NULL,
    associated_services VARCHAR(255) DEFAULT NULL,
    stage_name VARCHAR(255) DEFAULT NULL,
    tier_short VARCHAR(255) DEFAULT NULL,
    total_opportunity_quantity VARCHAR(255) DEFAULT NULL,
    start_date VARCHAR(255) DEFAULT NULL,
    year_created VARCHAR(255) DEFAULT NULL
);
"""

DEFAULT_OPPORTUNITY_LINE_ITEM_CREATE_TABLE_QUERY = """
CREATE TABLE opportunity_line_item (
    id SERIAL PRIMARY KEY,
    opportunity_id VARCHAR(255) DEFAULT NULL,
    product_id VARCHAR(255) DEFAULT NULL,
    profit_center_name VARCHAR(255) DEFAULT NULL,
    country VARCHAR(255) DEFAULT NULL,
    product_name VARCHAR(255) DEFAULT NULL,
    quantity VARCHAR(255) DEFAULT NULL,
    unit_price VARCHAR(255) DEFAULT NULL,
    FOREIGN KEY (opportunity_id) REFERENCES all_opportunity(opportunity_id)
);
"""

DEFAULT_POSTGRES_DATABASE_SCHEMAS_MAP = [
    {
        "db_name": "all_opportunity",
        "query": DEFAULT_ALL_OPPORTUNITIES_CREATE_TABLE_QUERY,
    },
    {
        "db_name": "opportunity_line_item",
        "query": DEFAULT_OPPORTUNITY_LINE_ITEM_CREATE_TABLE_QUERY,
    },
]

DEFAULT_DELETE_ALL_OPPORTUNITY_TABLE = "DELETE FROM all_opportunity WHERE true"
DEFAULT_DELETE_OPPORTUNITY_LINE_ITEM_TABLE = (
    "DELETE FROM opportunity_line_item WHERE true"
)
